/*
****************************************************************************

              Copyright 1991, by FUJITSU LIMITED
              Copyright 1991, by Sun Microsystems, Inc.	      

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED and Sun
Microsystems, Inc. not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.



****************************************************************************
*/


#ifndef _XSunIMTrans_already_DEFINED
#define _XSunIMTrans_already_DEFINED

#include <X11/Xresource.h>

#define TM_MaxParseState_Count		3
#define TM_ParseState_PreeditEdit	0
#define	TM_ParseState_PreeditConv	1
#define	TM_ParseState_LookupChoice	2

typedef char *		String;
typedef int		Cardinal;
typedef long		Boolean;

typedef struct _TranslationData	*   HttTranslations;
typedef struct _ActionListRec *	    ActionList;
typedef struct _TMMethodRec *	    TMMethodList;
typedef struct _TMEventSeq *	    TMEventSeqPtr;

typedef void	(*HttActionProc)(/* iml_inst_t *, String *, Cardinal */);

typedef struct	_HttActionRec {
    String		string;
    HttActionProc	proc;
} HttActionRec, *HttActionList;

typedef struct _TMMethodRec {
    void		(*tm_make_translations)();
    Boolean		(*tm_match_event)();
    void		(*tm_add_eventSeq)();
    void		(*tm_clear_eventSeq)();
    void		(*tm_add_action)();
    void		(*tm_unmatch_action)();
    Boolean		(*tm_event_to_String)();
} TMMethodRec;

typedef struct _HttTCRec {
    struct _HttTCRec	*next;
    struct _iml_session	*sc;
    TMMethodList	 tm;
    char		 bindName[64];
    HttTranslations	 parse_table[TM_MaxParseState_Count];
    ActionList		 action_table;
    TMEventSeqPtr	 curEventSeq;
    int			 translation_mode;
    Boolean		 isStackQuarks;
    short		 numQuarks;
    short		 quarkTblSize;
    XrmQuark		*quarkTbl;
    void		(*unmatchProc)();
    String		*unmatchParams;
    int			 unmatchNum;
} HttTCRec, *HttTCid;

#ifndef	XtNumber
#define	XtNumber(array)		((int )(sizeof(array)/sizeof(array[0])))
#endif

#ifndef Public
#define Public		extern
#endif
#ifndef Private
#define	Private		static
#endif

/* Prototypes */
Public HttTCid		Htt_CreateTC(
#if NeedFunctionPrototypes
	void	*sc
#endif
);

Public void		Htt_DestroyTC(
#if NeedFunctionPrototypes
	HttTCid	closed_tc_id
#endif
);

#endif /* _XSunIMTrans_already_DEFINED */
